package main

import (
	"fmt"

	"golang.org/x/tour/tree"
)

// Walk 步进 tree t 将所有的值从 tree 发送到 channel ch。
func Walk(t *tree.Tree, ch chan int) {
	switch {
	case t == nil:
		return
	case t != nil:
		Walk(t.Left, ch)
		ch <- t.Value
		Walk(t.Right, ch)
	}
}

// Same 检测树 t1 和 t2 是否含有相同的值。
func Same(t1, t2 *tree.Tree) bool {
	c1, c2 := make(chan int, 10), make(chan int, 10)
	go Walk(t1, c1)
	go Walk(t2, c2)
	for v1 := range c1 {
		for v2 := range c2 {
			println(v1, v2)
			if v1 != v2 {
				return false
			}
		}
	}
	return true
}

func main() {
	res := Same(tree.New(1), tree.New(1))
	fmt.Println(res)
}
